using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Runtime.Serialization;
using System.Text;
using System.Windows.Forms;

using Syncfusion.Diagnostics;
using Syncfusion.Windows.Forms.Grid;

namespace StartGDBG
{
    
    public class ExceptionCellModel : GridGenericControlCellModel
    {
        
        protected ExceptionCellModel(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {

        }
        protected override Size OnQueryPrefferedClientSize(Graphics g, int rowIndex, int colIndex, GridStyleInfo style, GridQueryBounds queryBounds)
        {
           
            //Calculate the size of the control
            ExceptionControl ec = Grid[rowIndex, colIndex].Tag as ExceptionControl;
            Size size = ec.Size;
            size.Height +=2;
            size.Width += 2;
            
            return size;
            
        }
        public ExceptionCellModel(GridModel pGrid)
            : base(pGrid)
        {
        }
        public override GridCellRendererBase CreateRenderer(GridControlBase control)
        {
            
            return new ExceptionCellRenderer(control, this);
        }
        public static void InitializeExceptionCell(ExceptionControl ec, GridStyleInfo style, int RowIndex, int ColIndex)
        {
            style.Control = ec;
            ExceptionData ex = null;
            try
            {
                ex = (ExceptionData)style.CellValue;
                ec.MyLabel = ex.Label;
                ec.MyText = ex.Note;
                
            }
            catch (Exception e) { string s = e.Message;  }
                           
            
        }
    }
    
    public class ExceptionData
    {
        
        public string Label;
        public string Note;
        
        public ExceptionData(string l, string n)
        {
            Label = l;
            Note = n;
        }
        public ExceptionData()
        {
        }
        
    }
}