using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Windows.Forms;
using System.Text;
using System.IO;
using System.Data;

using Syncfusion.Diagnostics;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;

namespace StartGDBG
{
    /// <summary>
    /// Summary description for DropDownImageCellRenderer.
    /// </summary>
    public class ExceptionCellRenderer : GridGenericControlCellRenderer
    {
        ExceptionControl ec = new ExceptionControl();      
        public ExceptionCellRenderer(GridControlBase grid, GridCellModelBase cellModel)
            : base(grid, cellModel)
        {
            SetControl(ec);
                    
        }
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                
            }

            base.Dispose(disposing);
        }

        protected override void OnDraw(Graphics g, Rectangle clientRectangle, int rowIndex, int colIndex, GridStyleInfo style)
        {

            ExceptionControl ec = Grid.Model[rowIndex, colIndex].Tag as ExceptionControl;
            style.Control = ec;
            ExceptionCellModel.InitializeExceptionCell(ec, Grid.GetViewStyleInfo(rowIndex, colIndex), rowIndex, colIndex);
            base.OnDraw(g, clientRectangle, rowIndex, colIndex, style);
                
        }



        protected override void OnInitialize(int rowIndex, int colIndex)
        {
           
            ExceptionCellModel.InitializeExceptionCell(ec, Grid.GetViewStyleInfo(rowIndex, colIndex), rowIndex, colIndex);
            
        }
    }
}
