using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid;
namespace StartGDBG
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private GridModelDataBinder gridBinder = null;
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(32, 24);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(550, 600);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(600, 650);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
            

            GridModelDataBinder gridBinder = this.gridDataBoundGrid1.Binder;
            
			this.gridDataBoundGrid1.DataMember = "Table1";
			this.gridDataBoundGrid1.DataSource = GetDataTables();
            GridHierarchyLevel hlT2 = gridBinder.AddRelation("Relation_Table1_Table2");
			GridHierarchyLevel hlT1 = gridBinder.RootHierarchyLevel;
			
            SetHiddenCols(hlT1, 0, 0);
            SetHiddenCols(hlT2, 0, 0);
            hlT1.LayoutColumns(
                new string[] { "Col1", "Col2", "Col3", "Col4", "Col5","Col6" });
            hlT2.LayoutColumns(
                new string[] { "", "", "", "Col4", "Col5", "" });
            hlT2.ShowHeaders = false;

            // binding a column to user control
            this.gridDataBoundGrid1.Model.CellModels.Add("ExceptionEntry", new ExceptionCellModel(this.gridDataBoundGrid1.Model));
            ExceptionControl control = new ExceptionControl();
            foreach (GridBoundColumn c in hlT1.GridBoundColumns)
                if (c.HeaderText == "Col6")
                {
                    c.StyleInfo.CellType = "ExceptionEntry";
                    c.StyleInfo.Tag = control;
                }
            // fit the size of the row/column
          
            this.gridDataBoundGrid1.Model.RowHeights.ResizeToFit(GridRangeInfo.Table());
            this.gridDataBoundGrid1.Model.ColWidths.ResizeToFit(GridRangeInfo.Table()); 
           
            this.gridDataBoundGrid1.DefaultRowHeight = 30;
            this.gridDataBoundGrid1.DefaultColWidth = 50;
			this.gridDataBoundGrid1.ExpandAll();
            
			
		}
        void SetHiddenCols(GridHierarchyLevel level, int hIndexFrom, int hIndexTo)
        {

            int Colcount = level.InternalColumns.Count;
            string[] layout = new string[Colcount - 1];
            for (int j = hIndexTo; j >= hIndexFrom; j--)
                for (int i = 0; i < Colcount; i++)
                {
                    if (i < j)
                        layout[i] = level.InternalColumns[i].MappingName;
                    else if (i > j)
                        layout[i - 1] = level.InternalColumns[i].MappingName;
                }
            level.LayoutColumns(layout);
        }
		private DataSet GetDataTables()
		{
			DataSet ds = new DataSet("MyHierarchicalDataSet");
			DataTable dt = new DataTable("Table1");

			int nCols = 7; // columns 4-5 correspond to the second table's columns
            // the last one is for user control - ExceptionControl
			int nRows = 10;
            dt.Columns.Add(new DataColumn("PK"));
			for(int i = 1; i < nCols -1 ; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));
            // column to be bound to ExceptionControl in the root data table
            dt.Columns.Add(new DataColumn("Col6", typeof(ExceptionData)));
            ExceptionData ed;
			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString(); // key column
				for(int j = 1; j < nCols - 3; j++)
					dr[j] = string.Format("row{0} col{1}", i+1, j);
                ed = new ExceptionData("My note","note " + (i + 1).ToString());
                dr[6] =  ed; // bound to user controls
				dt.Rows.Add(dr);
			}
			ds.Tables.Add(dt);

			// add 2-nd level
			dt = new DataTable("Table2");
			nCols = 3;
			nRows = 20;
            dt.Columns.Add(new DataColumn("FK"));
			for(int i = 1; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i+3)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = (i<10?i:i-10).ToString(); // foreign key column
				for(int j = 1; j < nCols; j++)
					dr[j] = string.Format("row{0} col{1}", i+1, j+3);
				dt.Rows.Add(dr);
			}
			ds.Tables.Add(dt);

			ds.Relations.Add(
				ds.Tables[0].Columns[0],
				ds.Tables[1].Columns[0]);
			ds.Relations[0].RelationName = "Relation_Table1_Table2";

            
			return ds;
		}
	}
}
